#pragma once

// Include all necessary headers from the ADTF SDK
#include <adtffiltersdk/adtf_filtersdk.h>

// For simplicity use the necessary namespaces
using namespace adtf::util;
using namespace adtf::ucom;
using namespace adtf::base;
using namespace adtf::streaming;
using namespace adtf::filter;

// To implement a Filter we subclass adtf::filter::cFilter.
// We implement IPropertyObserver as well in order to be notified about changes to our Properties.
class cPropertiesObserverFilter: public cFilter, public IPropertyObserver
{
public:
    // This macros provides some meta information about our Filter Implementation
    // This will be exposed by the plugin class factory.
    ADTF_CLASS_ID_NAME(cPropertiesObserverFilter,
                       "properties_observer_filter.filter.adtf_guides.cid",
                       "Properties Observer Filter");

public:
    // In the constructor, we setup all aspects of our Filter.
    cPropertiesObserverFilter();

    // This is our callback implementation.
    void Notify(const IProperty& oProperty) override;
};
